import {
  inject,
  TestBed
} from '@angular/core/testing';

import { App } from './app.component';
import { AppState } from './app.service';

describe('App', () => {
  // provide our implementations or mocks to the dependency injector
  beforeEach(() => TestBed.configureTestingModule({
    providers: [
      AppState,
      App
    ]}));

  it('should have a name', inject([ App ], (app: App) => {
    expect(app.name).toEqual('Levi 9 angular 2 seed');
  }));

  it('should have defined state', inject([ AppState ], (appState: AppState) => {
    expect(appState.state).toBeDefined();
  }));

  it('should prevent mutation of the state', inject([ AppState ], (appState: AppState) => {
    expect( () => { appState.state = 'yeah'; }).toThrowError('do not mutate the `.state` directly');
  }));

  it('should be able to set and get property of state',
    inject([ AppState ], (appState: AppState) => {
    appState.set('prop', 'value');
    expect(appState.get('prop')).toBe('value');
  }));

  it('should be able to handle get of unknown prop', inject([ AppState ], (appState: AppState) => {
    expect(appState.get('prop')).toEqual(appState.state);
  }));

  it('should log initial app state to console at start', inject([ App ], (app: App) => {
    spyOn(console, 'log');
    app.ngOnInit();
    expect(console.log).toHaveBeenCalled();
  }));

});
